// Code scaffolded by goctl. Safe to edit.
// goctl 1.9.2

package player

import (
	"errors"
	"juwan-backend/common/utils/responses"
	"net/http"

	"github.com/zeromicro/go-zero/rest/httpx"
	"juwan-backend/app/player/api/internal/logic/player"
	"juwan-backend/app/player/api/internal/svc"
	"juwan-backend/app/player/api/internal/types"
)

// 初始化当前用户的打手资料
func InitPlayerHandler(svcCtx *svc.ServiceContext) http.HandlerFunc {
	return func(w http.ResponseWriter, r *http.Request) {
		var req types.EmptyResp
		if err := httpx.Parse(r, &req); err != nil {
			httpx.ErrorCtx(r.Context(), w, err)
			return
		}

		l := player.NewInitPlayerLogic(r.Context(), svcCtx)
		resp, err := l.InitPlayer(&req)
		if err != nil {
			if errors.Is(err, player.ErrPlayerNotEligible) {
				httpx.ErrorCtx(r.Context(), w, responses.NewErrorResp(http.StatusForbidden, err))
				return
			}
			httpx.ErrorCtx(r.Context(), w, err)
		} else {
			httpx.OkJsonCtx(r.Context(), w, resp)
		}
	}
}
